#include <stdio.h>
#include <windows.h>
#include <stdio_ext.h>
#define delay(n) Sleep(n)
#define A 65
#define B 66
#define C 67
#define D 68
#define E 69
#define F 70
int button_A_interface(void);
int button_B_interface(void);
int button_C_interface(void);
int button_D_interface(void);
int button_E_interface(void);
int button_F_interface(void);
void input_manager(int key);
void monitor(void);
void keyborad(void);
void time_setting(void);
void temp_setting(void);
void menu_setting(void);
void mode_setting(void);
void monitor_controller(void);
void start_cancel(void);
void light_controller(void);
void light_on(void);
void light_off(void);
void sound_controller(void);
void beep_sound(void);
void backlight(void);
void speaker(void);

struct button
{
	boolean b_A;
	boolean b_B;
	boolean b_C;
	boolean b_D;
	boolean b_E;
	boolean b_F;
};
struct variable
{
	int c_value;
	int d_value;
	int e_value;
	int f_value;
	char *mode;
	char *menu;
	int light;
	int sound;
	int time;
	int temp;
	int temp_s;
	int check;
};

struct button button_Data;
struct variable variable_Data;

int main_controller(void)
{
	int i = 0;
	button_Data.b_A = 0;
	button_Data.b_B = 0;
	button_Data.b_C = 0;
	button_Data.b_D = 0;
	button_Data.b_E = 0;
	button_Data.b_F = 0;

	variable_Data.c_value = 0;
	variable_Data.d_value = 0;
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	variable_Data.light = 0;
	variable_Data.menu = "00 : MANUAL";
	variable_Data.mode = "TIME";
	variable_Data.sound = 0;
	variable_Data.temp = 20;
	variable_Data.temp_s = 20;
	variable_Data.time = 0;
	variable_Data.check = 1;
	while(1)
	{
		
		monitor();
		keyborad();

		if(button_Data.b_A ==1)
			input_manager(button_A_interface());
		if(button_Data.b_B ==1)
			input_manager(button_B_interface());
		if(button_Data.b_C ==1)
			input_manager(button_C_interface());
		if(button_Data.b_D ==1)
			input_manager(button_D_interface());
		if(button_Data.b_E ==1)
			input_manager(button_E_interface());
		if(button_Data.b_F ==1)
			input_manager(button_F_interface());
		if(i==0)
		{
			variable_Data.c_value = 0;
			variable_Data.d_value = 0;
			variable_Data.e_value = 0;
			variable_Data.f_value = 0;
			variable_Data.light = 0;
			variable_Data.menu = "00 : MANUAL";
			variable_Data.mode = "TIME";
			variable_Data.sound = 0;
			variable_Data.temp = 20;
			variable_Data.temp_s = 20;
			variable_Data.time = 0;
			i++;
		}
		monitor_controller();
		monitor();
		sound_controller();
		monitor();
		light_controller();
		delay(1000);
		
		
	}

	return 0;
}

void keyborad(void)
{
	if(GetAsyncKeyState(A))
		button_Data.b_A = 1;
	if(GetAsyncKeyState(B))
		button_Data.b_B = 1;
	if(GetAsyncKeyState(C))
		button_Data.b_C = 1;
	if(GetAsyncKeyState(D))
		button_Data.b_D = 1;
	if(GetAsyncKeyState(E))
		button_Data.b_E = 1;
	if(GetAsyncKeyState(F))
		button_Data.b_F = 1;

	__fpurge(stdin);
	__fpurge(stdout);
}
int button_A_interface(void)
{
	return 1;
}
int button_B_interface(void)
{
	return 2;
}
int button_C_interface(void)
{
	return 3;
}
int button_D_interface(void)
{
	return 4;
}
int button_E_interface(void)
{
	return 5;
}
int button_F_interface(void)
{
	return 6;
}
void input_manager(int key)
{
	switch(key)
	{
		case 1:
		{
			break;
		}
		case 2:
		{
			break;
		}
		case 3:
		{
			if(variable_Data.e_value == 0&& variable_Data.f_value == 0)
			{
				if(variable_Data.d_value == 0)
				{
					if(variable_Data.c_value == 1)
						variable_Data.c_value = 0;
					else if(variable_Data.c_value == 0)
						variable_Data.c_value = 1;
				}
			}
			break;
		}
		case 4:
		{
			if(variable_Data.e_value == 0 && variable_Data.f_value == 0)
			{
				if(variable_Data.c_value == 0)
				{
					variable_Data.d_value++;
					if(variable_Data.d_value == 6)
						variable_Data.d_value = 0;
				}
				else
				{
					button_Data.b_D = 0;
				}
			}
			break;
		}
		case 5:
		{
			if(variable_Data.f_value == 0)
			{
			if(variable_Data.e_value == 0 && (variable_Data.time != 0 || variable_Data.temp != 20))
				variable_Data.e_value = 1;
			else if (variable_Data.e_value == 1)
				variable_Data.e_value = 0;
			}
			else if(variable_Data.f_value == 1)
				button_Data.b_E = 0;
			break;
		}
		case 6:
		{
			if(variable_Data.e_value == 0)
			{
				if(variable_Data.f_value == 0)
					variable_Data.f_value = 1;
				else if (variable_Data.f_value == 1)
					variable_Data.f_value = 0;
				button_Data.b_F = 0;
			}
			break;
		}
	}
}
		
void monitor(void)
{
	if(variable_Data.light == 1 || variable_Data.f_value==1)
	{
		if(variable_Data.c_value == 0)
		{
			if((variable_Data.time%60)<=59&&(variable_Data.time%60)>=10)
				printf("\033[%dm  0%d  :  %d\n \033[0m",33, variable_Data.time/60,(variable_Data.time%60));
			else
				printf("\033[%dm  0%d  :  0%d\n \033[0m",33, variable_Data.time/60,(variable_Data.time%60));
		}
		else if(variable_Data.c_value ==1)
			printf("\033[%dm  %dC  /  %dC\n \033[0m",33,variable_Data.temp,variable_Data.temp_s);
		
		printf("\033[%dm  MODE : %s\n \033[0m",33,variable_Data.mode);
		printf("\033[%dm  MENU : %s\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n \033[0m",33,variable_Data.menu);
	}
	else
	{
		if(variable_Data.c_value == 0)
		{
			if(variable_Data.time == 600)
				printf("\033[%dm  %d  :  0%d\n \033[0m",37, variable_Data.time/60,(variable_Data.time%60));
			else
				printf("\033[%dm  0%d  :  %d0\n \033[0m",37, variable_Data.time/60,(variable_Data.time%60)/10);
		}
		else if(variable_Data.c_value == 1)
			printf("\033[%dm  %dC  /  %dC\n \033[0m",37,variable_Data.temp,variable_Data.temp_s);
		
		printf("\033[%dm  MODE : %s\n \033[0m",37,variable_Data.mode);
		printf("\033[%dm  MENU : %s\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n \033[0m",37,variable_Data.menu);
	}
}
void speaker(void)
{
	Beep(350,100);
}
void backlight(void)
{
	if(variable_Data.light == 1 || variable_Data.f_value==1)
	{
		if(variable_Data.c_value == 0)
		{
			if((variable_Data.time%60)<=59&&(variable_Data.time%60)>=10)
				printf("\033[%dm  0%d  :  %d\n \033[0m",33, variable_Data.time/60,(variable_Data.time%60));
			else
				printf("\033[%dm  0%d  :  0%d\n \033[0m",33, variable_Data.time/60,(variable_Data.time%60));
		}
		else if(variable_Data.c_value ==1)
			printf("\033[%dm  %dC  /  %dC\n \033[0m",33,variable_Data.temp,variable_Data.temp_s);
		
		printf("\033[%dm  MODE : %s\n \033[0m",33,variable_Data.mode);
		printf("\033[%dm  MENU : %s\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n \033[0m",33,variable_Data.menu);
	}
	else
	{
		if(variable_Data.c_value == 0)
		{
			if(variable_Data.time == 600)
				printf("\033[%dm  %d  :  0%d\n \033[0m",37, variable_Data.time/60,(variable_Data.time%60));
			else
				printf("\033[%dm  0%d  :  %d0\n \033[0m",37, variable_Data.time/60,(variable_Data.time%60)/10);
		}
		else if(variable_Data.c_value == 1)
			printf("\033[%dm  %dC  /  %dC\n \033[0m",37,variable_Data.temp,variable_Data.temp_s);
		
		printf("\033[%dm  MODE : %s\n \033[0m",37,variable_Data.mode);
		printf("\033[%dm  MENU : %s\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n \033[0m",37,variable_Data.menu);
	}
}

void monitor_controller(void)
{
	if(variable_Data.e_value == 0 && variable_Data.f_value == 0)
	{
		
		if((button_Data.b_A == 1|| button_Data.b_B==1)&&variable_Data.c_value == 0&&variable_Data.d_value==0)
		{
			time_setting();
			button_Data.b_A = 0;
			button_Data.b_B = 0;
		}
		if((button_Data.b_A == 1|| button_Data.b_B==1) && variable_Data.c_value ==1&&variable_Data.d_value==0)
		{
			temp_setting();
			button_Data.b_A = 0;
			button_Data.b_B = 0;
		}
		if(button_Data.b_C == 1 && variable_Data.d_value == 0)
		{
			mode_setting();
			button_Data.b_C = 0;
		}
		if(button_Data.b_D == 1 && variable_Data.c_value == 0)
		{
			menu_setting();
			button_Data.b_D = 0;
		}
	}
	if(button_Data.b_E ==1||variable_Data.e_value ==1||variable_Data.e_value == 2)
	{
		start_cancel();
		button_Data.b_E = 0;
	}
}
void time_setting(void)
{
	if(button_Data.b_A == 1)
	{
		if(variable_Data.time < 600)
			variable_Data.time += 10;
		else if (variable_Data.time==600)
			variable_Data.time = 0;
	}
	else if(button_Data.b_B == 1)
	{
		if(variable_Data.time < 580)
			variable_Data.time += 30;
		else if(variable_Data.time>=580 && variable_Data.time<600)
			variable_Data.time = 590;
		else if(variable_Data.time == 600)
			variable_Data.time = 0;
	}
}
void temp_setting(void)
{
	if(button_Data.b_A == 1)
	{
		if(variable_Data.temp < 90)
			variable_Data.temp += 10;
		else if(variable_Data.temp == 90)
			variable_Data.temp = 20;
	}
	else if(button_Data.b_B == 1)
	{
		if(variable_Data.temp < 80)
			variable_Data.temp += 20;
		else if(variable_Data.temp >= 80 && variable_Data.temp<90)
			variable_Data.temp = 90;
		else if(variable_Data.temp == 90)
			variable_Data.temp = 20;
	}
}
void mode_setting(void)
{
	if(variable_Data.d_value == 0)
	{
		if(variable_Data.c_value == 0)
		{
			variable_Data.mode = "TIME";
			variable_Data.temp = 20;
		}
		else if(variable_Data.c_value == 1)
		{
			variable_Data.mode = "TEMP";
			variable_Data.time = 0;
		}
	}
}
void menu_setting(void)
{
	if(variable_Data.c_value == 0)
	{
		switch(variable_Data.d_value)
		{
			case 0:
			{
				variable_Data.time = 0;
				variable_Data.menu = "00 : MENUAL";
				break;
			}
			case 1:
			{
				variable_Data.time = 60;
				variable_Data.menu = "01 : RICE CAKE";
				break;
			}
			case 2:
			{
				variable_Data.time = 90;
				variable_Data.menu = "02 : RICE SOUP";
				break;
			}
			case 3:
			{
				variable_Data.time = 120;
				variable_Data.menu = "03 : RICE";
				break;
			}
			case 4:
			{
				variable_Data.time = 300;
				variable_Data.menu = "04 : SOUP";
				break;
			}
			case 5:
			{
				variable_Data.time = 120;
				variable_Data.menu = "05 : PIZZA";
				break;
			}
		}
	}
}
void start_cancel(void)
{
	if(variable_Data.e_value == 1)
	{
		variable_Data.light = 1;
		if(variable_Data.c_value == 0)
		{
			variable_Data.time--;
			if(variable_Data.time == 1)
				variable_Data.e_value = 2;
		}
		else if(variable_Data.c_value ==1)
		{
			
			if(variable_Data.check%3 == 0)
			{
				variable_Data.temp_s += 10;
				if(variable_Data.temp_s == variable_Data.temp)
					variable_Data.e_value = 2;
			}
			variable_Data.check++;
		}
	}
	else if(variable_Data.e_value == 2)
	{
		variable_Data.d_value = 0;
		variable_Data.menu = "00 : MANUAL";
		variable_Data.light = 0;
		variable_Data.time = 0;
		variable_Data.temp = 20;
		variable_Data.temp_s = 20;
		variable_Data.sound = 1;
		variable_Data.e_value = 0;
		button_Data.b_A = 0;
		button_Data.b_B = 0;
		button_Data.b_C = 0;
		button_Data.b_D = 0;
		button_Data.b_F = 0;
	}
	else if (variable_Data.e_value ==0)
	{
		variable_Data.d_value = 0;
		variable_Data.menu = "00 : MANUAL";
		variable_Data.light = 0;
		variable_Data.time = 0;
		variable_Data.temp = 20;
		variable_Data.temp_s = 20;
	}
}
void light_controller(void)
{
	if(variable_Data.f_value == 1||variable_Data.e_value == 1||variable_Data.e_value == 2)
		light_on();
	else if(variable_Data.f_value == 0)
		light_off();
}
void light_on(void)
{
	variable_Data.light = 1;
	//backlight(); --> cunit test ʿ 
}
void light_off(void)
{
	variable_Data.light = 0;
	//backlight(); --> cunit test ʿ 
}
void sound_controller(void)
{
	if(variable_Data.sound == 1)
		beep_sound();
}
void beep_sound(void)
{
	variable_Data.check = 0;
	while(variable_Data.check<3)
	{
		delay(1000);
		speaker();
		variable_Data.check++;
	}
	variable_Data.sound =0;
	__fpurge(stdin);
	__fpurge(stdout);
	//while(getchar() != '\n') ;
}